/**
 * Copyright (c) 2013-2022, Alibaba Group Holding Limited;
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.aliyun.polardbx.binlog.storage;

import org.apache.commons.lang3.StringUtils;
import org.junit.Assert;
import org.junit.Test;

import java.io.File;
import java.io.IOException;
import java.util.Properties;

/**
 * created by ziyang.lb
 **/
public class RocksDBOptionUtilTest {

    @Test
    public void testGetSectionProperties() throws IOException {
        String path = System.getProperty("user.dir");
        path = StringUtils.substringBeforeLast(path, "/") + "/polardbx-cdc-common/src/main/resources/rocksdb.ini";

        File iniFile = new File(path);
        Properties properties1 = RocksDBOptionUtil.getSectionProperties(iniFile, "DBOptions");
        Assert.assertEquals(properties1.size(), 76);
        Properties properties2 = RocksDBOptionUtil.getSectionProperties(iniFile, "CFOptions");
        Assert.assertEquals(properties2.size(), 58);
    }
}
